# -*- coding: utf8 -*

from google.appengine.api import xmpp
from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app

from  google.appengine.api import users

from google.appengine.api import mail
#from google.appengine.api import mail

from google.appengine.ext import db

from google.appengine.api import memcache

import time
from datetime import datetime, timedelta

import hashlib

import parsers
#

class MudInfo(db.Model):
    server = db.StringProperty(required=True)
    user = db.StringProperty(required=True)
    enabled = db.BooleanProperty(required=True)

class LineTrigger(db.Model):
  line = db.StringProperty(required=True)
  action = db.StringProperty(required=True)
  tag = db.StringProperty(required=True)
  enabled = db.BooleanProperty(required=True)

class CommandHist(db.Model):
    send_time = db.DateTimeProperty(auto_now=True)
    command = db.StringProperty(required=True)
    param = db.StringProperty()

class Alias(db.Model):
    name = db.StringProperty(required=True)
    action = db.StringProperty(required=True)

import scripts

def execute_sys_action(user, server, cmd, arg):
    if cmd == '#wait':
        time.sleep(int(arg))
    elif cmd == '#debug':
        xmpp.send_message(user, '[['+arg+']]')
    elif cmd == '#call':
        tmp = arg.partition(' ')
        methodToCall = getattr(scripts, tmp[0])
        methodToCall(user, server, tmp[2])
    elif cmd == '#do':
        al = db.GqlQuery('SELECT * FROM Alias WHERE name=:1', arg).get()
        if(al!=None):
            execute_action(user, server, al.action)
    elif cmd == '#enable':
        tr = db.GqlQuery('SELECT * FROM LineTrigger WHERE enabled = False and tag=:1', arg)
        for item in tr:
            item.enabled = True
            item.put()
            xmpp.send_message(user, 'Trigger [['+item.line+']] is enabled.')
    elif cmd == '#disable':
        xmpp.send_message(user, '#disable command')
        tr = db.GqlQuery('SELECT * FROM LineTrigger WHERE enabled = True and tag=:1', arg)
        for item in tr:
            item.enabled = False
            item.put()
            xmpp.send_message(user, 'Trigger [['+item.line+']] is disabled.')
    elif cmd == '#report':
        mail.send_mail(sender='hello@hfgong-chat.appspotmail.com',
                         to='hfgong@hyphone.org',
                         subject='Report message from Sou Xian Ji',
                         body='example report')
        

def execute_action(user, server, action):
  for line in action.split(';'):
    if len(line) ==0:
      continue
    if line[0] == '#':
      cmdl = line.partition(' ');
      cmd = cmdl[0]
      num = cmd[1:]
      if not num.isdigit():
        execute_sys_action(user, server, cmd, cmdl[2]);
        continue;
      for ii in range(int(num)):
        xmpp.send_message(server, cmdl[2])
        tmp = line.partition(' ')
        ch = CommandHist(command=tmp[0], param=tmp[2])
        ch.put()
    else:
      xmpp.send_message(server, line)
      tmp = line.partition(' ')
      ch = CommandHist(command=tmp[0], param=tmp[2])
      ch.put()


class XMPPHandler(webapp.RequestHandler):
  def post(self):
    
    message = xmpp.Message(self.request.POST)
    cmdl = message.body.partition(' ');
    senderl = message.sender.partition('/');

    cmd = cmdl[0].lower();
    sender = senderl[0];

    fromserver = db.GqlQuery('SELECT * FROM MudInfo WHERE enabled = True and server=:1', sender).get()

    if( fromserver != None):

      server = fromserver.server
      user = fromserver.user

      qx = memcache.get('qx')
      qx_max = memcache.get('qx_max')
      qx_cen = memcache.get('qx_cen')
      js = memcache.get('js')
      js_max = memcache.get('js_max')
      js_cen = memcache.get('js_cen')
      nl = memcache.get('nl')
      nl_max = memcache.get('nl_max')


      xmpp.send_message(user, message.body)

      #tmp = db.GqlQuery('SELECT * FROM LineTrigger Where action=:1', 'kill er yitai')
      #tmp_line = tmp.get().line
      #xmpp.send_message(user, '++++'+tmp.get().line+'----')

      lines = message.body.split('\n')

      for line in lines:
        #if tmp_line == line:
        #  xmpp.send_message(user, '++++'+line+'=='+tmp_line)
        #else:
        #  xmpp.send_message(user, '++++'+line+'!='+tmp_line)

        triggers=db.GqlQuery('SELECT * FROM LineTrigger WHERE enabled = True and line=:1', line)

        for item in triggers:
          execute_action(user, server, item.action)


        if line.find(u'【闲聊】') == 0:
          mail.send_mail(sender='hello@hfgong-chat.appspotmail.com',
                         to='hfgong@hyphone.org',
                         subject='Chat message from Sou Xian Ji',
                         body=message.body)

      parsers.parse_message(user, server, lines)
      xmpp.send_message(user, u'气血：'+str(qx)+'/'+str(qx_max)+'('+str(qx_cen)+u'%), 精神：'
                        +str(js)+'/'+str(js_max)+'('+str(js_cen)+u'%); 内力：' +str(nl))
      return

    fromuser = db.GqlQuery('SELECT * FROM MudInfo WHERE enabled = True and user=:1', sender).get()

    if( fromuser != None ):
      server = fromuser.server
      user = fromuser.user

      if cmd == '##invite':
        xmpp.send_invite(server)
      elif cmd == '##send':
        xmpp.send_message(server, cmdl[2])      
        xmpp.send_message(user, cmdl[2])
      else:
        execute_action(user, server, message.body)


class MainPage(webapp.RequestHandler):
  def get(self):
    self.response.out.write('Welcome to Journey to The West.\nPlease type help to begin.');
    message = xmpp.Message({'from': '', 'to': '', 'body': ''});


class AntiIdlePage(webapp.RequestHandler):

  def get(self):
    fromserver = db.GqlQuery('SELECT * FROM MudInfo WHERE enabled = True').get()

    if( fromserver != None):

      server = fromserver.server
      user = fromserver.user
      execute_action(user, server, '#do hello')

      #xmpp.send_message(server, 'l')

class CleanCmdHistPage(webapp.RequestHandler):

  def get(self):
    oldcmd = db.GqlQuery('SELECT * FROM CommandHist WHERE send_time <:1', datetime.today()-timedelta(seconds=3600))
    for item in oldcmd:
        item.delete()

class HandleEmailPage(webapp.RequestHandler):
    def post(self):
        message = mail.InboundEmailMessage(self.request.body)
        if hashlib.sha224(message.sender).hexdigest() != 'f3e6ae2aa46f90926a4cab35ca3f0cc1998b2241f8f7807d751d3a99':
            return
        fromuser = db.GqlQuery('SELECT * FROM MudInfo WHERE enabled = True').get()
        if( fromuser != None ):
            server = fromuser.server
            user = fromuser.user
            #subject
            #xmpp.send_message(user, message.sender)
            #xmpp.send_message(user, 'subject='+message.subject)
            #xmpp.send_message(user, 'subject='+message.subject)
            execute_action(user, server, message.subject)
            #xmpp.send_message(user, 'body='+message.body)
            #xmpp.send_message(user, 'html='+message.html)


application = webapp.WSGIApplication([('/', MainPage),
                                      ('/anti_idle', AntiIdlePage),
                                      ('/clean_cmd_hist', CleanCmdHistPage),
                                      ('/_ah/mail/.+', HandleEmailPage), 
                                      ('/_ah/xmpp/message/chat/', XMPPHandler)],
                                     debug=True)

def main():
  run_wsgi_app(application)

if __name__ == "__main__":
  main()
  
  #p = MudInfo(server="souxianji001@gmail.com", user="haifeng.gong@gmail.com", enabled=True)
  #p.put()
  #p = LineTrigger(line=u'知客僧死了。', action='get silver from corpse', enabled=True, tag='make_money')
  #p.put()
