# -*- coding: utf8 -*

from google.appengine.api import xmpp
from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app

from  google.appengine.api import users

from google.appengine.api import mail

from google.appengine.api import memcache


import re

from google.appengine.ext import db

import chinese_number

def parse_hp(user, server, line):
    if len(line) ==0:
        return

    hp1 = u' 气血：( *)(\d+)( *)/( *)(\d+)( *)\(( *)(\d+)%\)( *)内力：( *)(\d+)( *)/( *)(\d+)( *)\(( *)(\d+)%\)( *)\(\+(\d+)\)'
    a = re.match(hp1, line)
    if a != None:
        #xmpp.send_message(user, 'qx: '+ a.group(2) + '/' +a.group(5)+'/'+a.group(8)+'/'+a.group(11)+'/'+a.group(14)+'/'+a.group(17))
        qx = int(a.group(2))
        qx_max = int(a.group(5))
        qx_cen = int(a.group(8))
        nl = int(a.group(11))
        nl_max = int(a.group(14))
        memcache.set_multi({'qx': qx, 
                            'qx_max': qx_max, 
                            'qx_cen': qx_cen,
                            'nl' : nl,
                            'nl_max' : nl_max})
        #xmpp.send_message(user, 'qx: ' + str(qx))
    else:
        hp2 = u' 精神：( *)(\d+)( *)/( *)(\d+)( *)\(( *)(\d+)%\)( *)法力：( *)(\d+)( *)/( *)(\d+)( *)\(( *)(\d+)%\)( *)\(\+(\d+)\)'
        a = re.match(hp2, line)
        if a != None:
            #xmpp.send_message(user, 'js: '+ a.group(2) + '/' +a.group(5)+'/'+a.group(8)+'/'+a.group(11)+'/'+a.group(14)+'/'+a.group(17))
            js = int(a.group(2))
            js_max = int(a.group(5))
            js_cen = int(a.group(8))
            fl = int(a.group(11))
            fl_max = int(a.group(14))
            memcache.set_multi({'js': js, 
                                'js_max': js_max, 
                                'js_cen': js_cen,
                                'fl' : fl,
                                'fl_max' : fl_max})
        else:
            hp3 = u' 食物：( *)(\d+)( *)/( *)(\d+)( *)武学：( *)(\d+)'
            a = re.match(hp3, line)
            if a != None:
                #xmpp.send_message(user, 'parse: ' + a.group(0))
                sw = int(a.group(2))
                sw_max = int(a.group(5))
                wx = int(a.group(8))
                memcache.set_multi({'sw': sw, 
                                    'sw_max': sw_max, 
                                    'wx': wx})

                #xmpp.send_message(user, 'sw: '+ a.group(2) + '/' +a.group(5)+'/'+a.group(7))
            else:
                hp4 = u' 饮水：( *)(\d+)( *)/( *)(\d+)( *)道行：( *)(\S+)年(\S+)天'
                a = re.match(hp4, line)
                if a!= None:
                    #xmpp.send_message(user, 'parse: ' + a.group(0))
                    #xmpp.send_message(user, 'ys: '+ a.group(2) + '/' +a.group(5)+'/'+a.group(8)+'/'+a.group(9))
                    nian = chinese_number.numeric(a.group(8))
                    tian = chinese_number.numeric(a.group(9))
                    #xmpp.send_message(user, a.group(8) +'='+str(nian)+', '+a.group(9)+'='+str(tian))
                    ys = int(a.group(2))
                    ys_max = int(a.group(5))

                    memcache.set_multi({'ys': ys, 
                                        'ys_max': ys_max, 
                                        'nian': nian,
                                        'tian' : tian})

                else:
                    hp5 = u' 潜能：( *)(\d+)( *)杀气：( *)(\d+)'
                    a = re.match(hp5, line)
                    if a != None:
                        #xmpp.send_message(user, 'parse: ' + a.group(0))
                        #xmpp.send_message(user, 'qn: '+ a.group(2) + '/' +a.group(5))
                        qn = int(a.group(2))
                        sq = int(a.group(5))
                        memcache.set_multi({'qn': qn, 
                                            'sq': sq})

                    #else:
                    #    xmpp.send_message(user, 'parse fail: '+line)

    #u'精神：  425/  425 (100%)    法力：  500 /  500 ( 33%) (+10)'
    #u'食物：  866/  300           武学： 77074'
    #u'饮水：  860/  300           道行： 一百四十九年一百一十二天'
    #u'潜能： 4472                 杀气： 1570'


# 0: hp
# 1: i

def classify_message(user, server, lines):
    if len(lines) == 0:
        return -1
    if lines[0].find(u' 气血：')==0 :
        return 0
    elif lines[0].find(u'你身上带着下列这些东西')==0 :
        return 1
    elif len(lines)>2 and lines[0].endswith(u' -') and lines[1]==u'   ':
        return 2

def parse_message(user, server, lines):
    c = classify_message(user, server, lines)
    if c==0:
        for line in lines:
            parse_hp(user, server, line)

        
