

def syllables (text):
   text = " " + text + " "

   vowel_list       = ['a', 'e', 'i', 'o', 'u', 'y']
   vowel_pairs      = ['ai', 'au', 'aw', 'ee','ea', 'oa', 'oi', 'ou', 'oo', 'ow', 'oy', 'uu']
   consonant_list   = ['b', 'c', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 'n', 'p', 'q', 'r', 's', 't', 'v', 'w', 'x', 'z']
   consonant_blends = ['bl', 'br', 'ch', 'chr', 'cl', 'cr', 'dr', 'fl', 'fr', 'gl', 'gr', 'kn', 'pl', 'pr',
                       'sc', 'sh', 'sk', 'sl', 'sm', 'sn', 'sp','spr', 'squ', 'st', 'str', 'sw',
                       'th', 'tr', 'thr', 'nt', 'wh']

   # Cut numbers in digits
   p = re.compile ("([0-9])([0-9])", re.IGNORECASE)
   for i in range (2):
       text = p.sub ("\\1#\\2", text)

   # Cut i / vowel (- o) / consonant
   p = re.compile ("i([aeiuy])([bcdfghjklmnpqrstvwxz])", re.IGNORECASE)
   text = p.sub ("i+\\1+\\2", text)

   # Cut the / vowel / consonant
   p = re.compile ("the([aeiouy])([bcdfghjklmnpqrstvwxz])", re.IGNORECASE)
   text = p.sub ("the+\\1+\\2", text)

   # Cut vowel / vowel except for pairs
   position = 0
   while position < len (text)-1:
       if text [position] in vowel_list and text [position+1] in vowel_list:
           if not (text [position:position+2] in vowel_pairs):
               if not (text [position-1:position+3] in ["tion", "dual", "nion", "quir", "tiou"]):
                   text = text [:position+1] + "_" + text [position+1:]
       position = position + 1

   # Cut consonant / consonant (ll, mm, ...)
   p = re.compile ("([bcdfghjklmnpqrstvwxz])\\1([^ ])", re.IGNORECASE)
   text = p.sub ("\\1-\\1\\2", text)

   # Cut vowel / consonant vowel
   start = 0
   end = 0
   while start < len (text)-1:
       if text [start] in vowel_list and text [start+1] in consonant_list:
           end = start + 1
           while end <= len (text)-1 and text [end] in consonant_list:
               end = end + 1
           if end <= len (text)-1 and (text [start+1:end] in consonant_list or text [start+1:end] in consonant_blends) and text [end] in vowel_list and text [end:end+2] <> "e ":
               text = text [:start+1] + "/" + text [start+1:]
       start = start + 1

   # Cut vowel consonant / consonant+ vowel (trumpet, simple, understanding, ...)
   start = 0
   end = 0
   while start < len (text)-1:
       if text [start] in vowel_list and text [start+1] in consonant_list:
           end = start + 2
           while end <= len (text)-1 and text [end] in consonant_list:
               end = end + 1
           if end <= len (text)-1 and end > start+2 and text [end] in vowel_list:
               if not (text [start+1:end] in consonant_blends):
                   text = text [:start+2] + "-" + text [start+2:]
       start = start + 1

   # Return the words splitted
   return text

wordlist =  ["2008", "piano", "waffle", "kissing", "diode", "museum",
"simple", "hundred", "understanding", "trumpet", "paper", "preparing",
"strengh", "theatre", "facetious", "abstemious", "statement",
"consent", "extent", "event", "documents", "fire", "oil", "pattern",
"fireplace", "theme", "based", "site", "sites", "within", "browse",
"required", "ensures", "dictionary", "dichotomy", "pamphlet",
"methan", "etherosexual"]

for word in wordlist:
   print syllables (word)
   